(vl-load-com)

(defun insert_csv_blocks (
                     /
                     app doc model tag val
                     fpath file line ll
                     bname x y z inspt raw atts blk_o
                     ) 

  (setq fpath (getfiled "Select .csv file" "" "csv" 0))
  
  (if fpath
    (progn
      (setq app (vlax-get-acad-object)
            doc (vla-get-activedocument app)
            model (vla-get-modelspace doc)
      )
      
      (setq file (open fpath "r")
            line (read-line file)
      )
      (while line
        (setq line (LM:str->lst line ";")
              ll (length line)
        )
        
        (if (and 
              (<= 4 ll) ; length is at least 4: 1 bname and 3 coords
              (= 0 (rem ll 2)) ; attributes are in pairs
            )
          (progn
            (setq bname (car line))
            (if (and
                  (numberp (setq x (atof (nth 1 line))))
                  (numberp (setq y (atof (nth 2 line))))
                  (numberp (setq z (atof (nth 3 line))))
                )
              (progn
                
                (setq inspt (list x y z))
                (setq raw (cdr (cdr (cdr (cdr line))))
                      atts (list)
                      pair (list)
                      i 0
                )
                
                (while raw
                  (if (= 0 i) 
                    (progn
                      (setq tag (car raw)
                            i 1
                      )
                    )
                    (progn
                      (setq val (car raw)
                            pair (cons tag val)
                            atts (append atts (list pair))
                            i 0
                      )
                    )
                  )
                  (setq raw (cdr raw))
                )
                
                ; insert block
                (setq blk_o (vla-insertblock (vlax-3d-point inspt) bname 1 1 1 0))
                
                ; set attributes
                (if atts
                  (LM:vl-setattributevalues blk_o atts)
                )
                
              )
            )
          )
        )
        
        (setq line (read-line file))
      )
      
      (close file)
    )
  )
  
  (princ)
)